// 013 u_c_tstringlist
// 03 jan 2002

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

// -- documentation at http://www.jcolibri.com

// xxx: the elements
// yyy: the payload

(*$r+*)

unit u_c_tstringlist;
  interface
    uses Classes, u_c_basic_object;

    type c_xxx_list= Class; // forward

         c_xxx= // one "xxx"
                Class(c_basic_object)
                  public
                    // -- not the same name as the tStringList
                    m_c_parent_xxx_list: c_xxx_list;
                    m_yyy: String;

                    Constructor create_xxx(p_name: String; p_c_xxx_list: c_xxx_list;
                        p_yyy: String); Virtual;
                    function f_display_xxx: String;
                    Destructor Destroy; Override;
                end;

         c_xxx_list= // "xxx" list
                 Class(c_basic_object)
                   public
                     m_c_xxx_list: tStringList;

                     Constructor create_xxx_list(p_name: String); Virtual;

                     function f_xxx_count: Integer;
                     function f_c_xxx(p_xxx_index: Integer): c_xxx;
                     function f_index_of(p_xxx: String): Integer;
                     function f_c_find_by_xxx(p_xxx: String): c_xxx;
                     procedure add_xxx(p_xxx: String; p_c_xxx: c_xxx);
                     procedure add_element(p_xxx, p_yyy: String);
                     procedure add_unique_xxx(p_xxx, p_yyy: String);
                     procedure display_xxx_list;

                     Destructor Destroy; Override;
                   end;

  implementation
    uses SysUtils, u_c_display;

    // -- c_xxx

    Constructor c_xxx.create_xxx(p_name: String; p_c_xxx_list: c_xxx_list;
        p_yyy: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_parent_xxx_list:= p_c_xxx_list;
        m_yyy:= p_yyy;
      end; // create_xxx

    function c_xxx.f_display_xxx: String;
      begin
        Result:= Format('%-10s ', [m_name])+ m_yyy;
      end; // f_display_xxx

    Destructor c_xxx.Destroy;
      begin
        InHerited;
      end; // Destroy

    // -- c_xxx_list

    Constructor c_xxx_list.create_xxx_list(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_xxx_list:= tStringList.Create;
      end; // create_xxx_list

    function c_xxx_list.f_xxx_count: Integer;
      begin
        Result:= m_c_xxx_list.Count;
      end; // f_xxx_count

    function c_xxx_list.f_c_xxx(p_xxx_index: Integer): c_xxx;
      begin
        Result:= c_xxx(m_c_xxx_list.Objects[p_xxx_index]);
      end; //  f_c_xxx

    function c_xxx_list.f_index_of(p_xxx: String): Integer;
      begin
        Result:= m_c_xxx_list.IndexOf(p_xxx);
      end; // f_index_of

    function c_xxx_list.f_c_find_by_xxx(p_xxx: String): c_xxx;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_xxx);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_xxx(m_c_xxx_list.Objects[l_index_of]);
      end; // f_c_find_by_xxx

    procedure c_xxx_list.add_xxx(p_xxx: String; p_c_xxx: c_xxx);
      begin
        m_c_xxx_list.AddObject(p_xxx, p_c_xxx);
      end; // add_xxx

    procedure c_xxx_list.add_element(p_xxx, p_yyy: String);
      begin
        m_c_xxx_list.AddObject(p_xxx, c_xxx.create_xxx(p_xxx, Self, p_yyy));
      end; // add_element

    procedure c_xxx_list.add_unique_xxx(p_xxx, p_yyy: String);
      begin
        if f_index_of(p_xxx)>= 0
          then
          else m_c_xxx_list.AddObject(p_xxx, c_xxx.create_xxx(p_xxx, Self, p_yyy));
      end; // add_unique_xxx

    procedure c_xxx_list.display_xxx_list;
      var l_xxx: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_xxx_count));

        for l_xxx:= 0 to f_xxx_count- 1 do
          display(f_c_xxx(l_xxx).f_display_xxx);
      end; // display_xxx_list

    Destructor c_xxx_list.Destroy;
      var l_xxx: Integer;
      begin
        for l_xxx:= 0 to f_xxx_count- 1 do
          f_c_xxx(l_xxx).Free;
        m_c_xxx_list.Free;

        Inherited;
      end; // Destroy

    begin // u_c_xxx
    end. // u_c_xxx
